/*
 * mpl-lib.h
 *
 * by Alexander Zhirov (alexander@zhirov.kz)
 * Telegram @alexanderzhirov
 */

#ifndef MPL_LIB_H_
#define MPL_LIB_H_

#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>

#define MPL_NAME "mportlink"
#define MPL_DEV_PATH "/dev/"
#define MPL_DONGLE_PATH (MPL_DEV_PATH "dongle/")

#define MPLOG(PRIORITY, fmt, ...) do { \
        char buf[256]; \
        snprintf(buf, sizeof(buf), fmt __VA_OPT__(,) __VA_ARGS__); \
        PRIORITY < LOG_WARNING && errno ? \
            syslog(PRIORITY, "%s(): %s (%s)", __func__, buf, strerror(errno)) : \
            syslog(PRIORITY, "%s(): %s", __func__, buf); \
    } while(0)

typedef struct
{
    int signal;
    int exit;
} MPL_CANCELLABLE;

char *mpl_get_copy_string(const char *str);

#endif
