/*
 * mpl-udev.h
 *
 * by Alexander Zhirov (alexander@zhirov.kz)
 * Telegram @alexanderzhirov
 */

#ifndef MPL_UDEV_H_
#define MPL_UDEV_H_

#include <libudev.h>
#include "mpl-lib.h"

typedef struct
{
    struct udev *context;
    struct udev_monitor *monitor;
    int fd;
} MPL_UDEV;

int mpl_udev_init(MPL_UDEV *udev);
void mpl_udev_free(MPL_UDEV *udev);
int mpl_udev_check_devices(MPL_UDEV *udev);
void mpl_udev_loop(MPL_UDEV *udev, MPL_CANCELLABLE *cancellable);

#endif
